#include "bsp_hw_i2c.h"


i2c_master_event_t sci_i2c3_event = I2C_MASTER_EVENT_ABORTED;
i2c_master_event_t sci_i2c4_event = I2C_MASTER_EVENT_ABORTED;

void i2c_init(void)
{
    fsp_err_t err;

    // initialize the sci3 i2c
    // scl - P408
    // sda - P409
    err = R_SCI_I2C_Open(&g_i2c3_ctrl, &g_i2c3_cfg);
    assert(FSP_SUCCESS == err);

    // initialize the sci3 i2c
    // scl - P206
    // sda - P207
    err = R_SCI_I2C_Open(&g_i2c4_ctrl, &g_i2c4_cfg);
    assert(FSP_SUCCESS == err);

}

/* SCI3 I2C interrupt callback */
void sci_i2c3_master_callback(i2c_master_callback_args_t *p_args)
{
    sci_i2c3_event = I2C_MASTER_EVENT_ABORTED;

    if (NULL != p_args)
    {
        /* capture callback event for validating the i2c transfer event*/
        sci_i2c3_event = p_args->event;
    }
}


/* SCI3 I2C interrupt callback */
void sci_i2c4_master_callback(i2c_master_callback_args_t *p_args)
{
    sci_i2c4_event = I2C_MASTER_EVENT_ABORTED;

    if (NULL != p_args)
    {
        /* capture callback event for validating the i2c transfer event*/
        sci_i2c4_event = p_args->event;
    }
}
