#include "my_da16200_AT.h"
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"
#include "hal_data.h"

#define DA16200_CMD_ATF       "ATF\r\n"
#define DA16200_CMD_WFMODE    "AT+WFMODE=0\r\n"
#define DA16200_CMD_RESTART   "AT+RESTART\r\n"
#define DA16200_CMD_ATE       "ATE\r\n"
#define DA16200_CMD_WFQAP     "AT+WFQAP\r\n"
#define DA16200_CMD_WFJAP     "AT+WFJAP=Xiaomi_FFF9,3,1,wangerxiao\r\n"
#define DA16200_CMD_NWDHC     "AT+NWDHC\r\n"
#define DA16200_CMD_TRTRM     "AT+TRTRM=2\r\n"
#define DA16200_CMD_TRUSE     "AT+TRUSE=1000\r\n"


static my_da16200_init_flag = 0;

void Uart0_Init();

void my_da16200_init()
{
    Uart0_Init();
    vTaskDelay(2000);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)&DA16200_CMD_ATF, sizeof(DA16200_CMD_ATF) - 1);
    vTaskDelay(2000);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_WFMODE, sizeof(DA16200_CMD_WFMODE) - 1);
    vTaskDelay(500);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_RESTART, sizeof(DA16200_CMD_RESTART) - 1);
    vTaskDelay(4000);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_ATE, sizeof(DA16200_CMD_ATE) - 1);
    vTaskDelay(500);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_WFQAP, sizeof(DA16200_CMD_WFQAP) - 1);
    vTaskDelay(500);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_WFJAP, sizeof(DA16200_CMD_WFJAP) - 1);
    vTaskDelay(8000);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_NWDHC, sizeof(DA16200_CMD_NWDHC) - 1);
    vTaskDelay(500);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_TRTRM, sizeof(DA16200_CMD_TRTRM) - 1);
    vTaskDelay(500);
    R_SCI_UART_Write(&g_uart0_ctrl, (uint8_t *)DA16200_CMD_TRUSE, sizeof(DA16200_CMD_TRUSE) - 1);
    vTaskDelay(1000);
    
    my_da16200_init_flag = 1;
}

void Uart0_Init()
{
    fsp_err_t err = FSP_SUCCESS;
    err = R_SCI_UART_Open(&g_uart0_ctrl, &g_uart0_cfg);
    assert(FSP_SUCCESS == err);
}

void my_da16200_send_data(uint8_t *send_data, uint8_t data_len)
{
    uint8_t send_temp[256] = {0x1B, 0x53, 0x32};
    uint8_t send_ip[] = {",192.168.2.255,1000,"};
    
    if(my_da16200_init_flag == 0)
        return;

    if(data_len >= 10)
    {
        send_temp[3] = data_len/10 + 0x30;
        send_temp[4] = data_len%10 + 0x30;
        memcpy(&send_temp[5], send_ip, sizeof(send_ip) - 1);
        memcpy(&send_temp[4 + sizeof(send_ip)], send_data, data_len);
        send_temp[4 + sizeof(send_ip) + data_len] = '\r';
        send_temp[5 + sizeof(send_ip) + data_len] = '\n';
        R_SCI_UART_Write(&g_uart0_ctrl, send_temp, data_len + sizeof(send_ip) + 6);
    }
    else
    {
        send_temp[3] = data_len%10 + 0x30;
        memcpy(&send_temp[4], send_ip, sizeof(send_ip) - 1);
        memcpy(&send_temp[3 + sizeof(send_ip)], send_data, data_len);
        send_temp[3 + sizeof(send_ip) + data_len] = '\r';
        send_temp[4 + sizeof(send_ip) + data_len] = '\n';
        R_SCI_UART_Write(&g_uart0_ctrl, send_temp, data_len + sizeof(send_ip) + 5);
    }
}

/* 串口中断回调 */
void Uart0_Callback(uart_callback_args_t *p_args)
{
    switch(p_args->event)
    {
        case UART_EVENT_RX_CHAR:
        {
            /* 把串口接收到的数据发送回去 */
            R_SCI_UART_Write(&g_uart9_ctrl, (uint8_t *)&(p_args->data), 1);

            break;
        }

		default:
		break;
    }
}
